
!HashedCollection class methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:24'!
arrayType
	^ Array! !

!HashedCollection methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:28'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := self class arrayType new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!HashedCollection methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:27'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := self class arrayType new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!HashedCollection methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:27'!
initialize: n
	"Initialize array to an array size of n"
	array := self class arrayType new: n.
	tally := 0! !

!Dictionary methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:25'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^ self class arrayType new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!Dictionary methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:25'!
keys
	"Answer an Array containing the receiver's keys."
	
	^ self class arrayType new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!Dictionary methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:26'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
	
 	| sortedKeys |
 	sortedKeys := self class arrayType 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!Dictionary methodsFor: '*O-Base-Compat' stamp: 'StefanMarr 4/29/2013 23:26'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (self class arrayType new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !
